#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include emitsoundany.inc

#pragma semicolon 1
#pragma newdecls required


#define PLUGIN_VERSION "1.0"

Handle g_PEnabled = INVALID_HANDLE;

bool g_bPiss[MAXPLAYERS + 1] =  { false, ... };
bool g_bCanPiss[MAXPLAYERS + 1] =  { true, ... };

int BeamSprite;
int HaloSprite;


public Plugin myinfo =
{
	name = "PissMod",
	author = "Andi67",
	description = "Enables pissing on Deaad Bodys",
	version = PLUGIN_VERSION,
	url = "www.andi67-blog.de.vu"
}

public void  OnPluginStart()
{
	g_PEnabled = CreateConVar("sm_piss_enabled", "1");
	
	HookEvent("player_hurt", EventPlayerHurt);
}

public void OnMapStart()
{
	BeamSprite = PrecacheModel("materials/sprites/laserbeam.vmt");
	HaloSprite = PrecacheModel("materials/sprites/halo.vmt");
	
	AddFileToDownloadsTable("materials/sprites/laserbeam.vmt");
	AddFileToDownloadsTable("materials/sprites/halo.vmt");	
	
	AddFileToDownloadsTable("sound/poop/pee.mp3");
	PrecacheSoundAny("poop/pee.mp3", true);
	
	AddFileToDownloadsTable("sound/poop/laugh.mp3");
	PrecacheSoundAny("poop/laugh.mp3", true);	
}

//////////////////////////
//		  EVENTS	    //
//////////////////////////

public void OnGameFrame()
{
	float pos[3];
	float end[3];
	float ang[3];
	for(int i = 1; i <=MaxClients; ++i)
	{
		if(IsClientConnected(i))
		{
			if(g_bPiss[i])
			{
				GetClientEyePosition(i, pos);
				GetClientEyeAngles(i, ang);
				pos[2] -= 23.0; 
				ang[0] = 50.0;
				
				TR_TraceRayFilter(pos, ang, MASK_PLAYERSOLID, RayType_Infinite, DontHitSelf, i);

				TR_GetEndPosition(end);
					
				TE_SetupBeamRingPoint(end, 5.0, 10.0, BeamSprite, HaloSprite, 0, 15, 0.5, 5.0, 1.0, {255, 255, 0, 255}, 10, 0);
				TE_SendToAll();
					
				float ppos[3];
								
				GetClientEyePosition(i, ppos);

				ppos[2]-=30.0;
					
				float aang[3];
						
				GetClientEyeAngles(i, aang);
						
				if(aang[1] > 0)
				{
					ppos[0]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), aang[1]));
					ppos[1]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(aang[1], 90.0))));
				}
				else
				{
					ppos[0]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(aang[1])));
					ppos[1]-=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(FloatAbs(aang[1]), 90.0))));
				}
					
						
				aang[0]=0.0;
				aang[1]+=180.0;
				aang[2]=0.0;
						
				TE_SetupBeamPoints(end, ppos, BeamSprite, HaloSprite, 1, 30, 0.1, 1.0, 1.0, 0, 10.0, {255, 255, 0, 255}, 10);
				TE_SendToAll();
			}
		}
	}
}

public Action EventPlayerHurt(Handle event, const char[] name, bool dontBroadcast)
{
	if(GetConVarInt(g_PEnabled) == 1)
	{	
		int victim = GetClientOfUserId(GetEventInt(event, "userid"));
		int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		
		if(g_bCanPiss[attacker])
		{
			char weapon[512];
			GetEventString(event, "weapon", weapon, sizeof(weapon));
		
			if (StrEqual(weapon,"knife",false)) 
			{	
				if(GetClientHealth(victim) < 1)
				{
					float rposition[3];
					float cposition[3];
//					GetEntDataVector(victim, Prop_Send, "m_vecOrigin", rposition);
					GetClientAbsOrigin(victim, rposition);				
					GetClientAbsOrigin(attacker, cposition);
					if(rposition[0] > cposition[0]-50 && rposition[0] < cposition[0]+50)
					{
						if(rposition[1] > cposition[1]-50 && rposition[1] < cposition[1]+50)
						{
							if(rposition[2] > cposition[2]-5 && rposition[2] < cposition[2]+5)
							{
								char attackername[32];
								char victimname[32];
								GetClientName(attacker, attackername, sizeof(attackername));
								GetClientName(victim, victimname, sizeof(victimname));							
							
								float pos[3];
								float end[3];
								float ang[3];
								GetClientEyePosition(attacker, pos);
								GetClientEyeAngles(attacker, ang);
								pos[2] -= 5.0; 
								ang[0] = 50.0;
								TR_TraceRayFilter(pos, ang, MASK_PLAYERSOLID, RayType_Infinite, DontHitSelf, attacker);
								TR_GetEndPosition(end);
							
								TE_SetupBeamRingPoint(end, 5.0, 10.0, BeamSprite, HaloSprite, 0, 15, 0.5, 5.0, 1.0, {255, 255, 0, 255}, 10, 0);
								TE_SendToAll();
	
								g_bPiss[attacker] = true;
								SetEntityMoveType(attacker, MOVETYPE_NONE);
							
								EmitAmbientSoundAny("poop/pee.mp3", pos);
								CreateTimer(0.8, EmitPissSound, attacker, TIMER_REPEAT);
							
							
								float ppos[3];
							
								GetClientEyePosition(attacker, ppos);

								ppos[0]+=10.0;
								ppos[2]-=30.0;
							
								float aang[3];
							
								GetClientAbsAngles(attacker, aang);
							
								if(aang[1] > 0)
								{
									ppos[0]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), aang[1]));
									ppos[1]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(aang[1], 90.0))));
								}
								else
								{
									ppos[0]+=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(aang[1])));
									ppos[1]-=FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(FloatAbs(aang[1]), 90.0))));
								}
							
								aang[0]=0.0;
								aang[1]+=180.0;
								aang[2]=0.0;
	
								TE_SetupBeamPoints(end, ppos, BeamSprite, HaloSprite, 0, 30, 0.1, 1.0, 1.0, 0, 10.0, {255, 255, 0, 255}, 10);
								TE_SendToAll();
								
								PrintToChatAll("[Piss-Mod] %s is pissing on %s's dead body.", attackername, victimname);
								EmitAmbientSoundAny("poop/laugh.mp3",ppos);
								CreateTimer(5.0 , Piss_Out , attacker);
								if(GetClientHealth(attacker) < 1)
								{
									CreateTimer(0.1 , Piss_Out , attacker);
								}
							}
						}
					}
				}
			}
		}
	}
}

public Action Piss_Out(Handle timer, any client)
{	
	g_bPiss[client] = false;
	g_bCanPiss[client] = false;
	
	if(IsValidClient(client))
	{	
		CreateTimer(0.1, CanPiss, client);
	
		SetEntityMoveType(client, MOVETYPE_WALK);
	}	
	return Plugin_Handled;
}

stock bool DontHitSelf(int entity, int mask, any data)
{
	if(entity == data)
		return false;
	return true;
}

public Action EmitPissSound(Handle timer, any client)
{
	if(!g_bPiss[client])
		return Plugin_Stop;
	
	if(IsValidClient(client))
	{
		float pos[3];
		GetClientAbsOrigin(client, pos);
	
		EmitAmbientSoundAny("poop/pee.mp3", pos);
	}
		
	return Plugin_Continue;
}

public Action CanPiss(Handle timer, any client)
{
	g_bCanPiss[client] = true;
		
	return Plugin_Continue;
}

stock bool IsValidClient(int client)
{
	if (client <= 0) return false;
	if (client > MaxClients) return false;
	if (!IsClientConnected(client)) return false;
	return IsClientInGame(client);
}